package com.baidu.music.common.plugin;

import com.baidu.music.common.plugin.PluginCallback;
import com.baidu.music.common.plugin.PluginTrack;

interface IPluginService {

    int getAPIVer();

    /**
     * 分享
     * @param songId 音乐id
     * @param title 标题
     * @param desc 描述
     * @param url 跳转地址
     * @param imageUrl 网络图片地址
     * @param imagePath 本地图片地址
     * @param shareType -1：未选择通过什么来进行分享，需要弹出dialog；ShareManager.OPTION_WEICHAT......
     */
    void share(long songId, String title, String desc, String url, String imageUrl, String imagePath, int shareType);

    void pause(); //暂停播放

    void nextSong(); //下一首

    void prevSong(); //上一首

    void playSong(in PluginTrack track); //播放歌曲

    int getPlayMode(); //获取当前播放模式

    boolean isPlaying(); //是否正在播放

    void playCurrent(); //播放当前歌曲

    void playLocalList(); //播放本地列表

    void registerCallback(PluginCallback callback); //注册回调

    void unregisterCallback(PluginCallback callback); //注销回调

    void toast(String str); //toast

    void pVLogin(String log); //log


}
