package com.baidu.util.audiocore;

public interface OnTaskDownloadDelegate {
    public final int TASK_STATE_INIT = -1; // init state
    public final int TASK_STATE_ERROR = 0; // error state
    public final int TASK_STATE_DOWNLOADING = 1; // downloading state
    public final int TASK_STATE_COMPLETED = 2; // complete state

    public final int TASK_ERROR_NO_ERROR = 0;
    public final int TASK_ERROR_SUCCESS = 1;
    public final int TASK_ERROR_CREATE_FILE_FAILED = 11;
    public final int TASK_ERROR_WRITE_FILE_FAILED = 12;
    public final int TASK_ERROR_NO_PEER = 21;
    public final int TASK_ERROR_CONNECT_PEER_FAILED = 22;
    public final int TASK_ERROR_REQUEST_ERROR = 23;
    public final int TASK_ERROR_GET1KDATA_ERROR = 28;
    public final int TASK_ERROR_DOWNLOADING_ERROR = 29;
    public final int TASK_ERROR_HTTP_SCHEDULE_FAILED = 30;
    public final int TASK_ERROR_NOT_BEGIN = 99;

    // callback for show progress
    void onTaskIdProgress(int nTaskId, int nProgress);

    // callback for status changed
    void onTaskIdStatusChanged(int nTaskId, int nNewState, int nOldState);

    // callback for error occured, not used
    void onTaskIdErrorCode(int nTaskId, int nState, int nErrorCode);

    // callback for download timeout
    void onTaskIdTimeout(int nTaskId);
}
