package com.baidu.util.localmatch;

public interface LocalMatchListener {

    public static final int ELocalMatchClientErrorStatusSuccess = 600;           // 成功
    public static final int ELocalMatchClientErrorStatusFPError = 601;           // 本地特征生成错误
    public static final int ELocalMatchClientErrorStatusTimeOut = 602;           // 超时
    public static final int ELocalMatchClientErrorStatusStopByUser = 603;        // 中断
    public static final int ELocalMatchClientErrorStatusUnknown = 604;           // 未知错误
    public static final int ELocalMatchClientErrorStatusServer = 606;            // 后端服务错误
    public static final int ELocalMatchClientErrorStatusAPIServer = 607;         // API服务错误
    public static final int ELocalMatchClientErrorStatusServerBusy = 608;        // 后端服务忙
    public static final int ELocalMatchClientErrorStatusNotSure = 609;           // 有返回结果但是不确定是否正确
    public static final int ELocalMatchClientErrorStatusNoResult = 610;          // 没有返回结果
    public static final int ELocalMatchClientErrorStatusMoreTimeMatch = 611;     // 多次较低分数命中同一首歌曲，可以认为成功
    public static final int ELocalMatchClientErrorStatusMaybeMatch = 612;        // 
    public static final int ELocalMatchClientErrorStatusParserFile = 613;

    public static final int LocalMatchFromMd5 = 001;             // 匹配来源md5-mfd-
    public static final int LocalMatchFromKeyWord = 002;             // 匹配来源关键字匹配-检索
    public static final int LocalMatchFromAudioFingerPrinting = 003;             // 匹配来源-音频指纹服务
        
    /**
     * @param fromtype 匹配来源 LocalMatchFromMd5/LocalMatchFromKeyWord/LocalMatchFromAudioFingerPrinting
     * @param status   匹配状态 ELocalMatchClientErrorStatusSuccess 认为匹配成功， 其他status均不认为匹配成功
     * @param result   匹配结果 json string 包括文件路径和匹配的songid   {"file_path":"/storage/emulated/0/local586421952.mp3","song_id":"586421952"}
     */
    public void onLocalMatchClientResult(int fromtype, int status, String result);

}
