package com.baidu.utility;

import android.graphics.Paint;
import android.text.InputFilter;
import android.text.SpannableString;
import android.text.Spanned;
import android.text.TextUtils;
import android.widget.TextView;

import java.math.BigDecimal;
import java.text.DateFormat;
import java.text.DecimalFormat;
import java.text.SimpleDateFormat;
import java.util.ArrayList;
import java.util.Date;
import java.util.List;
import java.util.Set;
import java.util.regex.Matcher;
import java.util.regex.Pattern;

public class StringUtils {


    public static String limitString(String strSrc, int start , int end){

        if (strSrc.length() > (end-start)) {
            String str_item = strSrc.substring(start, end) + "...";
            strSrc = str_item;
        }
        return strSrc;
    }
    /*
     * intToString。
     */
    public static String intToString(int n){
        return Integer.toString(n);
    }
    /*
     * 字符串是否为空。
     */
    public static boolean isEmpty(String str) {
        String string = str;
        if (string == null) {
            return true;
        }
        string = string.trim();
        return TextUtils.isEmpty(string) || str.equalsIgnoreCase("null");
    }

    /**
     * 只针对textView为1行的进行textSize调整。
     * textView 必须在布局中，固定大小。
     *
     * @param tv
     */
    public static void resizeTextView(final TextView tv) {
        if (tv == null) {
            return;
        }

        String text = tv.getText().toString();
        if (isEmpty(text)) {
            return;
        }
        Paint paint = tv.getPaint();
        float textSize = paint.measureText(text);
        float size = tv.getTextSize();
        int width = tv.getLayoutParams().width - tv.getPaddingLeft() - tv.getPaddingRight();
        if (width > textSize) {
            return;
        }
        while (width < textSize) {
            size -= 1;
            tv.setTextSize(size);
            textSize = paint.measureText(text);
        }
        tv.setTextSize(size);
    }

    public static int setTextViewLines(final TextView tv) {
        int lines = 0;
        if (tv == null) {
            return lines;
        }

        String text = tv.getText().toString();
        if (isEmpty(text)) {
            return lines;
        }
        Paint paint = tv.getPaint();
        float textSize = paint.measureText(text);
        float size = tv.getTextSize();
        int width = tv.getLayoutParams().width - tv.getPaddingLeft() - tv.getPaddingRight();
        if (width > textSize) {
            tv.setLines(1);
            lines = 1;
        } else {
            tv.setLines(2);
            lines = 2;
        }
        return lines;
    }

    /*
     * 字符串是否相等。
     */
    public static boolean equals(String str1, String str2) {
        if (str1 == null || str2 == null) {
            return (str1 == str2);
        }
        return str2.equals(str1);
    }

    public static long parseLong(String str) {
        try {
            return isEmpty(str) ? 0 : Long.parseLong(str);
        } catch (Exception e) {
            e.printStackTrace();
        }
        return 0;
    }

    //public static String md5(String string) {
        // if (string == null || string.trim().length() < 1) {
        // return null;
        // }
        // try {
        // return getMD5(string.getBytes("UTF-8"));
        // } catch (UnsupportedEncodingException e) {
        // }
        // return null;
      //  return MD5Util.encode(string);
   // }

    // private static String getMD5(byte[] source) {
    // try {
    // MessageDigest md5 = MessageDigest.getInstance("MD5");
    // StringBuffer result = new StringBuffer();
    // for (byte b : md5.digest(source)) {
    // result.append(Integer.toHexString((b & 0xf0) >>> 4));
    // result.append(Integer.toHexString(b & 0x0f));
    // }
    // return result.toString();
    // } catch (Exception e) {
    // }
    // return null;
    // }

   // public static String md5s(String plainText) {
        // String str = "";
        // try {
        // MessageDigest md = MessageDigest.getInstance("MD5");
        // md.update(plainText.getBytes());
        // byte b[] = md.digest();
        //
        // int i;
        //
        // StringBuffer buf = new StringBuffer("");
        // for (int offset = 0; offset < b.length; offset++) {
        // i = b[offset];
        // if (i < 0)
        // i += 256;
        // if (i < 16)
        // buf.append("0");
        // buf.append(Integer.toHexString(i));
        // }
        // str = buf.toString();
        // } catch (NoSuchAlgorithmException e) {
        // str = null;
        // }
        // return str;
    //    return MD5Util.encode(plainText);
   // }

    // public static String md5sLogin(String plainText) {
    // String str = "";
    // try {
    // MessageDigest md = MessageDigest.getInstance("MD5");
    // md.update(plainText.getBytes("GBK"));
    // byte b[] = md.digest();
    //
    // int i;
    //
    // StringBuffer buf = new StringBuffer("");
    // for (int offset = 0; offset < b.length; offset++) {
    // i = b[offset];
    // if (i < 0)
    // i += 256;
    // if (i < 16)
    // buf.append("0");
    // buf.append(Integer.toHexString(i));
    // }
    // str = buf.toString();
    // } catch (NoSuchAlgorithmException e) {
    // str = null;
    // } catch (UnsupportedEncodingException e) {
    // e.printStackTrace();
    // str = null;
    // }
    // return str;
    // }

    public static String escapeSql(String str) {
        if (str == null) {
            return null;
        }
        return replace(str, "'", "''");
    }

    public static String escapeFileName(String str) {
        if (str == null) {
            return null;
        }

        /** 非法字符包括：/\:*?"<>| */
        StringBuilder builder = new StringBuilder();
        for (int i = 0; i < str.length(); i++) {
            char c = str.charAt(i);
            if (c == '/' || c == '\\' || c == ':' || c == '*' || c == '?' || c == '"' || c == '<' || c == '>'
                    || c == '|') {
                continue;
            } else {
                builder.append(c);
            }
        }
        String ret = builder.toString();
        // 替换可能出现的\t
        if (ret != null) {
            ret = ret.replaceAll("\t", "");
        }
        return ret;
    }

    /**
     * reserved file name characters depend on filesystem mounted
     * refer to:  http://en.wikipedia.org/wiki/Filename
     *
     * @param str
     */
    public static String escapeMusicFileName(String str) {
        if (str == null) {
            return null;
        }

        String regEX = "[?:\"*|/\\<>]";
        Pattern p = Pattern.compile(regEX);
        Matcher m = p.matcher(str);
        str = m.replaceAll("").trim();

        return str;
    }

    public static String replace(String text, String searchString, String replacement) {
        return replace(text, searchString, replacement, -1);
    }

    public static String replace(String text, String searchString, String replacement, int max) {
        if (isEmpty(text) || isEmpty(searchString) || replacement == null || max == 0) {
            return text;
        }
        int start = 0;
        int end = text.indexOf(searchString, start);
        if (end == -1) {
            return text;
        }
        int replLength = searchString.length();
        int increase = replacement.length() - replLength;
        increase = (increase < 0 ? 0 : increase);
        increase *= (max < 0 ? 16 : (max > 64 ? 64 : max));
        StringBuffer buf = new StringBuffer(text.length() + increase);
        while (end != -1) {
            buf.append(text.substring(start, end)).append(replacement);
            start = end + replLength;
            if (--max == 0) {
                break;
            }
            end = text.indexOf(searchString, start);
        }
        buf.append(text.substring(start));
        return buf.toString();
    }

    public static int toInt(String str, int defaultValue) {
        if (TextUtils.isEmpty(str)) {
            return defaultValue;
        }
        try {
            return Integer.parseInt(str);
        } catch (NumberFormatException nfe) {
            return defaultValue;
        }
    }

    public static float toFloat(String str, float defaultValue) {
        if (TextUtils.isEmpty(str)) {
            return defaultValue;
        }
        try {
            return Float.parseFloat(str);
        } catch (NumberFormatException nfe) {
            return defaultValue;
        }
    }

    /**
     * @param pathA
     * @param pathB
     * @return
     */
    public static final boolean isPathChange(String pathA, String pathB) {
        boolean isPathChange = false;
        if (StringUtils.isEmpty(pathA)) {
            isPathChange = !StringUtils.isEmpty(pathB);
        } else {
            isPathChange = !pathA.equals(pathB);
        }
        return isPathChange;
    }

    public static String getTimeString(long time) {
        if (time <= 0) {
            return "0:00";
        }

        int min = (int) (time / 60);
        int second = (int) (time % 60);
        if (second < 10) {
            return min + ":0" + second;
        }
        return min + ":" + second;
    }

    public static boolean isABC(char c) {
        if ((c >= 'A' && c <= 'Z') || (c >= 'a' && c <= 'z')) {
            return true;
        }
        return false;
    }

    /**
     * 将首字母转换为合法的排序字母
     *
     * @param c 输入字符
     * @return 大写字母或"|"
     */
    public static char formatFirstLetter(char c) {
        if (c >= 'A' && c <= 'Z') {
            return c;
        }

        if (c >= 'a' && c <= 'z') {
            return (char) (c + ('A' - 'a'));
        }

        return '|';
    }

    /**
     * 获取字符串的长度，中文占一个字符,英文数字占半个字符
     *
     * @param value 指定的字符串
     * @return 字符串的长度
     */
    public static double chineseLength(String value) {
        if (TextUtils.isEmpty(value))
            return 0;

        double valueLength = 0;
        String chinese = "[\u4e00-\u9fa5]";
        // 获取字段值的长度，如果含中文字符，则每个中文字符长度为2，否则为1
        for (int i = 0; i < value.length(); i++) {
            // 获取一个字符
            String temp = value.substring(i, i + 1);
            // 判断是否为中文字符
            if (temp.matches(chinese)) {
                // 中文字符长度为1
                valueLength += 1;
            } else {
                // 其他字符长度为0.5
                valueLength += 0.5;
            }
        }
        // 进位取整
        return Math.ceil(valueLength);
    }

    public static double getStringLength(String value) {
        return TextUtils.isEmpty(value) ? 0 : value.length();
    }

    /**
     * 获得最大长度的汉字字串
     *
     * @param source
     * @param maxLength
     * @return
     */
    public static String getChineseStringByMaxLength(String source, int maxLength) {
        String cutString = "";
        double tempLength = 0;
        for (int i = 0; i < source.length(); i++) {
            String temp = source.substring(i, i + 1);
            String chinese = "[\u4e00-\u9fa5]";
            // 判断是否为中文字符
            if (temp.matches(chinese)) {
                // 中文字符长度为1
                tempLength += 1;
            } else {
                // 其他字符长度为0.5
                tempLength += 0.5;
            }
            cutString += temp;
            if (Math.ceil(tempLength) == maxLength) {
                break;
            }
        }
        return cutString;
    }

    public static String trim(String str) {
        if (isEmpty(str)) {
            return null;
        }
        return str.trim();
    }

    /**
     * [A-z0-9]{2,} 任意字母和数字组合，并长度大于等于2，必选
     * <p>
     * [@] 必选
     * <p>
     * [a-z0-9]{2,} 任意小写字母和数字组合，并长度大于等于2，必选
     * <p>
     * [.] 必选
     * <p>
     * \p{Lower}{2,} 任意小写字母，并长度大于等于2，必选
     * <p>
     *
     * @param emailString
     * @return
     */
    public static boolean validateEmailAddress(String emailString) {
        String format = "[A-z0-9]{2,}[@][a-z0-9]{2,}[.]\\p{Lower}{2,}";
        if (emailString.matches(format)) {
            return true;
        } else {
            return false;
        }
    }

    /**
     * 匹配格式： 11位手机号码 3-4位区号，7-8位直播号码，1－4位分机号 如：12345678901、1234-12345678-1234
     *
     * @param phoneString
     * @return
     */
    public static boolean validatePhoneNumber(String phoneString) {
        String format =
                "((\\d{11})|^((\\d{7,8})|(\\d{4}|\\d{3})-(\\d{7,8})|(\\d{4}|\\d{3})-(\\d{7," +
                        "8})-(\\d{4}|\\d{3}|\\d{2}|\\d{1})|(\\d{7,8})-(\\d{4}|\\d{3}|\\d{2}|\\d{1}))$)";
        if (phoneString.matches(format)) {
            return true;
        } else {
            return false;
        }
    }

    /**
     * 5-12位的数字
     *
     * @param qqString
     * @return
     */
    public static boolean validateQQNumber(String qqString) {
        String format = "^\\d{5,12}$";
        if (qqString.matches(format)) {
            return true;
        } else {
            return false;
        }
    }

    /**
     * 拼接后的字符串不带单引号，单引号是在数据库操作中会用到，这个函数只用在api请求
     *
     * @param list
     * @return
     */

    public static String getIdScopeStringNoQuotes(long[] list) {
        if (list == null || list.length == 0) {
            return null;
        }

        StringBuffer sb = new StringBuffer();
        for (long id : list) {
            sb.append(id).append(",");
        }

        return sb.substring(0, sb.length() - 1);
    }

    public static String getIdScopeString(List<Integer> list) {
        if (list == null || list.isEmpty()) {
            return null;
        }

        StringBuffer sb = new StringBuffer();
        for (Integer id : list) {
            sb.append("'").append(id).append("',");
        }

        return sb.substring(0, sb.length() - 1);
    }

    public static String getIdScopeString(ArrayList<Long> list) {
        if (list == null || list.isEmpty()) {
            return null;
        }

        StringBuffer sb = new StringBuffer();
        for (Long id : list) {
            sb.append("'").append(id).append("',");
        }

        return sb.substring(0, sb.length() - 1);
    }
    public static String getDotString(ArrayList<String> strs) {
        StringBuilder pics = new StringBuilder();
        for (String pic : strs) {
            if (!StringUtils.isEmpty(pic)) {
                pics.append(pic).append(",");
            }

        }
        if (pics.length() > 0) {
            // 最后的逗号去掉
            pics.deleteCharAt(pics.length() - 1);
        }
        return pics.toString();
    }

    public static String getIdScopeString(long[] list) {
        if (list == null || list.length == 0) {
            return null;
        }

        StringBuffer sb = new StringBuffer();
        for (long id : list) {
            sb.append("'").append(id).append("',");
        }

        return sb.substring(0, sb.length() - 1);
    }

    public static String getIdScopeString(Set<Long> set) {
        if (set == null || set.size() == 0) {
            return null;
        }

        StringBuffer sb = new StringBuffer();
        for (Long id : set) {
            sb.append("'").append(id).append("',");
        }

        return sb.substring(0, sb.length() - 1);
    }

    /**
     * 将一组id拼接成以逗号分隔的字符串
     * @param idlist id列表
     * @param splitNum 以多少数目为一组
     * @return 逗号分隔的字符串
     */
    public static List<String> getDotFormatString(List<Long> idlist, int splitNum) {
        List<String> stringList = new ArrayList<String>();
        if (idlist == null || idlist.isEmpty()) {
            return stringList;
        }
        int n = 0;
        if (splitNum > 0) {
            n = idlist.size() / splitNum;
        }
        for (int j = 0; j < n + 1; j++) {
            StringBuilder sb = new StringBuilder();
            // 从splitNum和最后循环剩余的歌曲两者数目取最小的值作为循环次数
            int loopNum = Math.min(splitNum, idlist.size() - j * 100);
            for (int i = j * 100; i < j * 100 + loopNum; i++) {
                sb.append(idlist.get(i));
                sb.append(",");
            }
            if (sb.length() > 0) {
                // 最后的逗号去掉
                sb.deleteCharAt(sb.length() - 1);
            }
            String idsStr = sb.toString();
            if (idsStr.length() > 0) {
                // 当idlist.size() / splitNum整除时,j的最后一次循环其实没有任何数据,所以这里判断有内容时才假如到stringList中
                stringList.add(idsStr);
            }
        }
      //  LogUtil.d("SongUtils", "[UserPlaylist] getDotFormatString: stringList = " + stringList.toString());
        return stringList;
    }

    /**
     * 将逗号拼成的id字符串分隔组成long型的list
     * @param dotString 逗号拼接的字符串
     * @return long型列表
     */
    public static List<Long> getIdListFromDotString(String dotString) {
        List<Long> idlist = new ArrayList<Long>();
        if (dotString == null || isEmpty(dotString)) {
            return idlist;
        }
        String[] strlist = dotString.split(",");
        for (String str : strlist) {
            try {
                long id = Long.parseLong(str);
                idlist.add(id);
            } catch (Exception e) {
               // LogUtil.d(e.getMessage());
            }
        }
        return idlist;
    }

    /***
     * 半角转换为全角
     *
     * @param input
     * @return
     */
    public static String toDBC(String input) {
        char[] c = input.toCharArray();
        for (int i = 0; i < c.length; i++) {
            if (c[i] == 12288) {
                c[i] = (char) 32;
                continue;
            }
            if (c[i] > 65280 && c[i] < 65375)
                c[i] = (char) (c[i] - 65248);
        }
        return new String(c);
    }

    public static String keepPrecision(String number, int precision) {
        BigDecimal bg = new BigDecimal(number);
        return bg.setScale(precision, BigDecimal.ROUND_HALF_UP).toPlainString();
    }

    /**
     *
     * @param apiPublishTime
     * @return
     */
    public static String getSinglePrePayPublishTime(String apiPublishTime) {
        if (isEmpty(apiPublishTime)) {
            return "";
        }
        String [] strs = apiPublishTime.split("-");
        if (strs == null || strs != null && strs.length < 3) {
            return "";
        }
        String result = strs[0] + "年"+ strs[1] + "月"+ strs[2] +"号";
        return result;
    }


    /**
     * 检测是否有emoji表情
     *
     * @param source
     * @return
     */
    public static boolean containsEmoji(String source) {
        int len = source.length();
        for (int i = 0; i < len; i++) {
            char codePoint = source.charAt(i);
            if (isEmojiCharacter(codePoint)) { //如果匹配,则该字符是Emoji表情
                return true;
            }
        }
        return false;
    }

    /**
     * 判断是否是Emoji
     *
     * @param codePoint 比较的单个字符
     * @return
     */
    private static boolean isEmojiCharacter(char codePoint) {
        if ((codePoint == 0x0) || (codePoint == 0x9) || (codePoint == 0xA)
                || (codePoint == 0xD)
                || ((codePoint >= 0x20) && (codePoint <= 0xD7FF))
                || ((codePoint >= 0xE000) && (codePoint <= 0xFFFD))
                || ((codePoint >= 0x10000) && (codePoint <= 0x10FFFF))) {
            return false;
        }
        return true;
    }

    /**
     * UGC中跟数字相关比如评论数目,万以下的数字按原数字展示,万以上需要以万单位显示,且保留一位小数,当小数位为0时则不显示小数。且不需要四舍五入
     * 比如:134632 显示13.4万;   1234 显示 1234 ;  10234 显示1万
     * @param num 待格式化的数字
     * @return
     */
    public static String formatNumToStringForUgc(long num) {
        if (num < 0 ) {
            return "0";
        }
        if (num < 10000) {
            return String.valueOf(num);
        }
        double numForTenThousand = num / 10000f;
        DecimalFormat formatRule = new DecimalFormat("#.#");
        return formatRule.format(numForTenThousand) + "万";
    }

    public static String join(List<String> stringList, String delimiter) {
        if (stringList == null || stringList.isEmpty()) {
            return "";
        }

        StringBuilder sb = new StringBuilder();
        for (Object str : stringList) {
            sb.append(str.toString()).append(delimiter);
        }
        sb.delete(sb.length() - delimiter.length(), sb.length());   // 删除最后的分隔符
        return sb.toString();
    }

    public static String replaceBlank(String content) {
        if(content==null){
            return null;
        }
        content = content.replaceAll("\\n+","\n");
        content = content.replaceAll(" +"," ");
        if(content.equals(" \\n")||content.equals("\\n ")){
            return null;
        }
        return  content;
    }
    public static String replaceAllBlank(String content) {
        if(content==null){
            return null;
        }
        content=content.trim();
        content = content.replaceAll("\\n","");
        content = content.replaceAll(" +"," ");
        if(content.equals(" \\n")||content.equals("\\n ")||content.equals(" ")){
            return null;
        }
        return  content;
    }

    public static String formatUgcTopicTitle(String title) {
        if (isEmpty(title)) {
            return null;
        }
        String topicTitle = "# " + title;
        return topicTitle;
    }

    public static InputFilter getInputFilterProhibitEmoji(final OnUnLegalStringListener listener) {
        InputFilter filter = new InputFilter() {
            @Override
            public CharSequence filter(CharSequence source, int start, int end,
                                       Spanned dest, int dstart, int dend) {
                StringBuffer buffer = new StringBuffer();
                for (int i = start; i < end; i++) {
                    char codePoint = source.charAt(i);
                    if (!isEmojiCharacter(codePoint)) {
                        buffer.append(codePoint);
                    } else {
                        i++;
                        if (listener != null) {
                            listener.onUnLegalString();
                        }
                        continue;
                    }
                }
                if (source instanceof Spanned) {
                    SpannableString sp = new SpannableString(buffer);
                    try {
                        TextUtils.copySpansFrom((Spanned) source, start, end, null, sp, 0);
                    } catch (IndexOutOfBoundsException e) {
                    }
                    return sp;
                } else {
                    return buffer;
                }
            }
        };
        return filter;
    }

    public static boolean checkForbiddenChar(String content) {
        if (StringUtils.isEmpty(content)) {
            return true;
        }
        String regex = "([\\u4e00-\\u9fa5]|[A-Z]|[a-z]|[0-9]|-|_){0,}";
        return !content.matches(regex);
    }

    public interface OnUnLegalStringListener {
        void onUnLegalString();
    }

    public static int compareDate(String DATE1, String DATE2, Boolean hasHourMinute) {

        DateFormat df;
        if(hasHourMinute){
           df  = new SimpleDateFormat("yyyy-MM-dd hh:mm");
        }else{
           df  = new SimpleDateFormat("yyyy-MM-dd");
        }
        try {
            Date dt1 = df.parse(DATE1);
            Date dt2 = df.parse(DATE2);
            if (dt1.getTime() > dt2.getTime()) {
                System.out.println("dt1 在dt2前");
                return 1;
            } else if (dt1.getTime() < dt2.getTime()) {
                System.out.println("dt1在dt2后");
                return -1;
            } else {
                return 0;
            }
        } catch (Exception exception) {
            exception.printStackTrace();
        }
        return 0;
    }
}
