package com.baidu.utility.api;

/**
 * Created by mingliang_yang on 2017/5/23.
 */


import java.io.IOException;

import okhttp3.Call;
import okhttp3.OkHttpClient;
import okhttp3.Request;
import okhttp3.Response;

import org.json.JSONException;
import org.json.JSONObject;

import com.baidu.utility.StringUtils;

import android.util.Log;



public class ApiController {

	private static final String TAG = ApiController.class.getSimpleName();

	/**
	 * Interface definition for a callback to be invoked when the media source is ready for playback.
	 */
	public interface OnApiControllerListener {

		public void onSuccess(int status, String what, int id);

		public void onError(int status, String what, int id);

		public void OnProgress(float progress, long total, int id);
	}

	/**
	 * Register a callback to be invoked when the media source is ready for playback.
	 *
	 * @param listener the callback that will be run
	 */
	public void setOnApiControllerListener(OnApiControllerListener listener) {
		mOnListener = listener;
	}

	public OnApiControllerListener mOnListener;


    private String mFrom;
        
    public void parserInit(String sys, String version, String channel) {
    	
    	//from=android&version=6.0.7.1&channel=360safe&operator=1
    	
    	if(!StringUtils.isEmpty(sys) && !StringUtils.isEmpty(version) && !StringUtils.isEmpty(channel)){
    		String strFrom = "from=" + sys;
        	String strVer = "&version=" + version;
        	String strChannel = "&channel=" + channel;
        	String strOpt = "&operator=1";
        	mFrom = strFrom + strVer + strChannel + strOpt;
    	}
    }

	private int parserReponse(String response, int id) {

		String errCode = null;
		try {
			//将字符串转换成jsonObject对象
			JSONObject myJsonObject = new JSONObject(response);

			//获取对应的值
			if(myJsonObject.has("error_code")){
				errCode = myJsonObject.getString("error_code");
				Log.e(TAG, "parserReponse errCode=" + errCode+ "response" +response+ "id=" +id);
			}else{
				Log.e(TAG, "parser errCode error " + "response" +response);
			}
		} catch (JSONException e) {

		}
		if(errCode == null){
			Log.e(TAG, " errCode" + errCode+ "response" +response);
			mOnListener.onError(-1, response, id);
			return -1;
		}


		int errIntCode = Integer.valueOf(errCode).intValue();

		if (errIntCode == ApiError.REPONSE_SUCCESS) {
			mOnListener.onSuccess(errIntCode, response, id);
		} else {
			mOnListener.onError(errIntCode, response, id);
		}

		return 0;
	}

	
	class requestinfo{
		int req;
		int info;
	}
	
	
	public String reqHttp(String reqUrl){
		
		 String result = null;
		 try {
			 OkHttpClient client = new OkHttpClient();
			    Request request = new Request.Builder().url(reqUrl).build();
			    Response response = client.newCall(request).execute();
			   
			    if (response.isSuccessful()) {
			    	result = response.body().string();
			    	Log.e(TAG, "reqHttp_Result= "+result);
			    } 
         } catch (IOException e) {
             e.printStackTrace();
         }
		 
		return result;
	}
	/*
	*		/*
	通过md5 查询歌曲的songid 
	http://192.168.3.242:8888/v1/restserver/ting?from=android&version=6.0.7.1&channel=360safe&operator=1method=baidu.ting.search.searchSongByMd5&md5=A5CA0B5894324F8BB54BB9FFFAD29D1E 
	

   *	public static final String SEARCH_BY_MD5 = APISERVER_MFD + "/v1/restserver/ting?";
	*
	*  返回值
	*  {
	* "song_id": ["204350"],
	* "error_code": 22000,
	* "total": 1
	* }
	*/
	public String getSongIdByMd5(String md5){
		if (mOnListener == null) {
			Log.e(TAG, "getSongIdByMd5：mOnListener == null");
			return null;
		}
		String strMd5 = "&md5=" + md5;	
		String reqUrl = ApiUrl.APISERVER + mFrom + ApiUrl.SEARCH_BY_MD5_METHOD + strMd5;
		Log.e(TAG, "local_match_MD5_ID= "+ApiConfig.API_LOCALMATCH_MD5_ID +"API:getSongIdByMd5: "+reqUrl);    
	    return reqHttp(reqUrl);
	}

	//http://192.168.3.242:8888//v1/restserver/ting?from=android&version=6.0.7.1&channel=360safe&operator=1&method=baidu.ting.search.searchSongByWord&singer=%E5%BC%A0%E4%BF%A1%E5%93%B2&songname=%E7%88%B1%E5%A6%82%E6%BD%AE%E6%B0%B4&duration=111&qa=1
	public String getSongIdByKeyWord(String singer, String songName, String durationSec) throws IOException {

		if (mOnListener == null) {
			Log.e(TAG, "getSongIdByMd5：mOnListener == null");
			return null;
		}
		String strSinger = "&singer=" + singer;
		String strSongName = "&songname=" + songName;
		String strDuration = "&duration=" + durationSec;
		
		String reqUrl = ApiUrl.APISERVER + mFrom + ApiUrl.SEARCH_BY_KEYWORD_METHOD + strSinger + strSongName + strDuration;
		Log.i(TAG, "local_match_KEYWORD_ID= "+ApiConfig.API_LOCALMATCH_KEYWORD_ID +"API:getSongIdByKeyWord: "+reqUrl);
	    return reqHttp(reqUrl);
	}
}
