package com.baidu.utility.api;

import android.util.Log;

import java.util.ArrayList;

import net.sf.json.JSONArray;
import net.sf.json.JSONObject;


/**
 * Created by mingliang_yang on 2017/6/6.
 */

public class ApiParser {
	private static final String TAG = ApiController.class.getSimpleName();

	private static ApiParser mInstance = new ApiParser();
	public static ApiParser getInstance() {
		return mInstance;
	}

	/*
	 * http://192.168.3.242:8888/v1/restserver/ting?method=baidu.ting.search.searchSongByMd5&qa=1&md5=A5CA0B5894324F8BB54BB9FFFAD29D1E
	{
	"song_id": ["204350"],
	"error_code": 22000,
	"total": 1
   }
	*/
	
	public String getSongIdFromResponse(String response) {
		String songid = null;
		JSONObject json_response = JSONObject.fromObject(response);
		String error_code  = json_response.getString("error_code");
		Log.i(TAG, "local_match_getSongIdFromKeyWord parserResponse error_code= "+error_code);
		
		if(ApiError.REPONSE_SUCCESS != Integer.valueOf(error_code).intValue()){
			Log.e(TAG, "local_match_parserResponse error"+error_code);
			return null;
		}
		
		JSONArray jsonArray = json_response.getJSONArray("song_id");
		String row = null;
		Log.i(TAG, "local_match_jsonArray.size() "+jsonArray.size());
		
		for (int i = 0; i < jsonArray.size(); i++) {
			row = jsonArray.getString(i);
			songid = jsonArray.getString(0);
			Log.i(TAG, "local_match_ index="+i+" songid= "+row);
		}
	      
		Log.i(TAG, "local_match_getSongIdFromKeyWord parserResponse songid= "+songid);
		return songid;
	}
	
}
